<?
  set_magic_quotes_runtime(FALSE); // just in case

  //********************************************************
  //*** basic configuration
  //********************************************************
    $blogname = "an example hl-- site";
    $blogurl = "http://www.cockos.com/hl--/";   // URL to main page
    $blogurl_rel = "//www.cockos.com/hl--/";    // URL in format for <LINK> tags, without any /index.php etc, just the path
    $num_articles = 6;    // how many articles to show on front page

    $comments_enabled = 1; // allow user comments (configuration below)
    $refer_log=1;  // log referers, show sites that link (configuration below)

  //********************************************************
  //*** path configuration
  //********************************************************
    $config_path = "articles";  // relative path to articles directory, which
    			        // usually includes articles, comments subdir,
                                // counter file, and referer logs, but you
                                // can customize those paths below, too.
                                // must NOT have trailing slash

    // these are subdirectories of config_path that can safely be left at 
    // their defaults.
    $article_dir = "$config_path";   // articles go in the directory directly
    $article_topfilename = "$config_path/article.top";
    $counter_filename = "$config_path/counter.txt";
    $comments_dir = "$config_path/comments"; // create this dir with 0777 perms if you will use comments
    $refer_dir = $config_path . "/refers";   // create this dir with 0777 perms if you will use referer logging


  //********************************************************
  //*** RSS configuration
  //********************************************************
    $rss_blogdesc = $blogname;    // <description> field
    $rss_num_articles = 12;       // number of articles to show
    $rss_use_full_html = 1;	  // 1 = full, 0 = excerpt
      $rss_num_desc_words = 24;	  // if not full HTML, minimum words

    function config_rss_fixstr($str) // custom RSS filtering
    {
      return $str;
    }

  //********************************************************
  //*** appearance configuration
  //********************************************************
    $hls_bodyconfig='bgcolor="#3f3f3f" text="#ffffff" link="#ffff00" alink="#ffff00" vlink="#ffff00"'; // any custom color settings for the <body> tag

    $center_article = 0;	// whether to <center> articles
    $hls_article_date_column_width = "150"; // width of left "date" column, can be in pixels, or percentage i.e. 10%

    // form configuration for search form and comment form
      $hls_formconfig = 
         '<style type="text/css"> .myform { border-top:#c0c0c0 solid thin; border-bottom:#c0c0c0 solid thin; ' .
         'border-right:#c0c0c0 solid thin; border-left:#c0c0c0 solid thin; color:#f0f0f0; ' . 
         'background:#303040; font-family:Courier; font-size:12px; border-width:1px; } </style>';
    
    // outer (border) table configuration -- set to false to disable border
      $hls_outer_table = 'border=1 CELLPADDING=4 CELLSPACING=0 HEIGHT=90% WIDTH=90% bgcolor="#2f2f2f" bordercolor="#000000"';

    // set our text that goes above the blog
      $hls_topline = "<center><h2>an example hl-- site!</h2></center>";

    // set our text that goes below the blog
      $hls_bottomline = 'Copyright &copy; the author : Powered by <a href="http://www.cockos.com/hl--/">hl--</a>';
      if ($article != "rc")  // show links to rss and recent comments, if not already in recent comments
        $hls_bottomline =  '<a href="rss.php">rss</a> : <a href="recent_comments.php">recent comments</a> : ' . $hls_bottomline;

      $hls_bottomline = "<center><font size=-1>$hls_bottomline";
      $hls_bottomline_end = "</font></center>"; // format bottom line like so

    // comments appearances
      $comments_dispsep = "<hr>"; // separate comments
      $comments_datestr = "D d M Y \\a\\t H:i";

    // navigation controls text and formatting
      $nav_maxviewpages=15; // max pages to show
 
      $nav_preprevlink = "<center><font size=\"-1\">[ ";
      $nav_postprevlink = " ]</font></center>";

      $nav_lastlink = "&lt;&lt;&lt; last (older) article"; // go to the next older article
      $nav_nextlink = "next (newer) article &gt;&gt;&gt;"; // go to the next most recent article
      $nav_inindexlink = "view in index"; // view current article in context
      $nav_preslink = "present"; // jump to the end of time
      $nav_pastlink = "past";   // jump to the beginning of time
      $nav_oldsearchresults = "older results...";
      $nav_newsearchresults = "newer results...";

    // search box settings
      $display_search="always"; // set to "always", "index", or anything else to disable
      $nav_searchfmt="<br><center>";
      $nav_searchfmt_end="</center>";



  //********************************************************
  //*** hit counter - only enabled on the main page default view
  //********************************************************
    $counter_enabled = 1;
    $counter_echo = " : Hits: "; // set to false to not echo, otherwise it will use this as a separator, following $hls_bottomline
    $counter_disallowip = ""; // don't update counter for any IP containing this string


  //********************************************************
  //*** referer logging configuration, shows nifty 
  //*** Sites linking here" for pages
  //********************************************************
    $refer_label = "Sites linking here:";
    $refer_maxdispsize=60; // show this many chars of URL max
    $refer_maxitems=15;    // show this many URLs max (shows only the oldest to deter spam)

    // ignore links containing these values
    // note that the ignoring happens when the link happens, so it will not ignore items
    // already in the referer list (you will have to manually delete any)
    $refer_ignorelist = array("http://www.cockos.com",
                           0); // 0 terminated list





  //********************************************************
  //*** internal stuff - no need to edit unless you are a 
  //***                  real control freak
  //********************************************************

  // if request is from rss or palm, or user-agent has PalmOS or Nokia, disable border, search box
  $is_palm = strstr(($useragent = $_SERVER['HTTP_USER_AGENT']), "PalmOS") || strstr($useragent, "Nokia") || $_REQUEST['palm']=="y";
  if ($is_palm || $_REQUEST['fromrss'] == "y")
  {
    $hls_outer_table=false;
    $display_search = "never";
  }


  if ($article != "rc") // normal RSS embed link
    $rss_embedlinkrel = "<LINK REL=\"alternate\" TITLE=\"$blogname RSS\" " . 
                        "HREF=\"$blogurl_rel" . "rss.php\" TYPE=\"application/rss+xml\">";
  else  // recent comments page embed link
    $rss_embedlinkrel = "<LINK REL=\"alternate\" TITLE=\"$blogname Recent Comments RSS\" " . 
                        "HREF=\"$blogurl_rel" . "recent_comments.php?rss=y\" TYPE=\"application/rss+xml\">";

  $hls_pretext = "<head><title>$blogname</title>$hls_formconfig</head>\n<body $hls_bodyconfig>\n$rss_embedlinkrel\n$hls_topline\n";
  if (!($hls_outer_table === false)) $hls_pretext .= "<center><table $hls_outer_table><tr><td valign=top>\n";

  // delimit comment files with this (only change if you have no comments in your comments dir)
  $comments_sep = "::!bushis-so-uber-gay!::"; // how to delimit the comments in file form

  if (!is_dir($config_path)) die("hl-- configuration path not found.");

?>
